//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "math.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#define POCETCYKLU 1000
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
c1 = c2 = 0;
w1=  0.001;
w2 = -0.001;
prah = (w1+w2)/2;
gama=0.1;
}


void TForm1::vykresli(TColor barva) {
#define POSUNX 0
#define POSUNY 0
PaintBox1->Canvas->Pen->Color = clRed;//clWhite;
PaintBox1->Canvas->Rectangle(0,0,PaintBox1->Width,PaintBox1->Height);
PaintBox1->Canvas->Pen->Color = clBlue;
for (unsigned int i = 0; i < c1; i++) {
  PaintBox1->Canvas->Ellipse(mnozinaC1[0][i]-5+POSUNX,mnozinaC1[1][i]-5+POSUNY,
  mnozinaC1[0][i]+5+POSUNX,mnozinaC1[1][i]+5+POSUNY);
}

PaintBox1->Canvas->Pen->Color = clMaroon;

for (unsigned int i = 0; i < c2; i++) {
  PaintBox1->Canvas->Ellipse(mnozinaC2[0][i]-5+POSUNX,mnozinaC2[1][i]-5+POSUNY,
  mnozinaC2[0][i]+5+POSUNX,mnozinaC2[1][i]+5+POSUNY);
}
PaintBox1->Canvas->Pen->Color= barva;
/*PaintBox1->Canvas->MoveTo(0,(int)(prah/w2));
PaintBox1->Canvas->LineTo((int)((prah-w2*PaintBox1->Width)/w1),
        PaintBox1->Width); */

PaintBox1->Canvas->MoveTo(0+POSUNX,(int) (prah/w2)+POSUNY);
PaintBox1->Canvas->LineTo(PaintBox1->Width+POSUNX,(int)((prah-w1*PaintBox1->Width)/w2)+POSUNY);

Label4->Caption = AnsiString(w1);
Label5->Caption = AnsiString(w2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (RadioButton1->Checked) {
  RadioButton1->Caption = "C1 " + AnsiString(c1+1);
 if (c1 == MAX-1) {
  RadioButton1->Enabled = false;
  return;
 }
  mnozinaC1[0][c1] = X;
  mnozinaC1[1][c1] = Y;
  c1++;
  }

 if (RadioButton2->Checked) {
 RadioButton2->Caption = "C2 " + AnsiString(c2+1);
 if (c2 == MAX-1) {
  RadioButton2->Enabled = false;
  return;
 }
  mnozinaC2[0][c2] = X;
  mnozinaC2[1][c2] = Y;
  c2++;
  }

  vykresli();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintBox1Paint(TObject *Sender)
{
vykresli();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Label1Click(TObject *Sender)
{

Label1->Visible = false;
cyklus = 0;
ny =10;
Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
double y;
double fi;
double e;
unsigned long int zmena;
cyklus++;
ny -= ny/POCETCYKLU;
zmena = 0;
        for (unsigned int i = 0; i < c1; i++) {
                fi=(double)w1*mnozinaC1[0][i]+(double)w2*mnozinaC1[1][i] - prah; //potencil
                if (fi > 10000.0)    // jinak to pretece
                        y = 1;
                else if (fi < -10000.0)
                        y = -1;
                else
                        y = 1/(1+exp(-gama*fi)); //y=(0,1) --sigmoida
                if (fi < 0.0) { //y == 1
                   e = (0.5-y);
                   w1 += ny*e*mnozinaC1[0][i]*0.0035;
                   w2 += ny*e*mnozinaC1[1][i]*0.0035;
                 prah += ny*0.5*(w1+w2);
                 Label9->Caption = AnsiString(prah);
                 zmena = 1;
                 vykresli(clBlue);
                }
        }

      for (unsigned int i = 0; i < c2; i++) {
                fi=(double)w1*mnozinaC2[0][i]+(double)w2*mnozinaC2[1][i] - prah;
                if (fi > 10000.0)
                        y = -1;
                else if (fi < -10000.0)
                        y = 1; // jinak to pretece
                else
                        y = 1/(1+exp(-gama*fi)); //y=(0,1)
                if (fi > 0.0) {
                   e = (0.5-y);
                   w1 += ny*e*mnozinaC2[0][i]*0.0035;
                   w2 += ny*e*mnozinaC2[1][i]*0.0035;
                 prah += ny*0.5*(w1+w2);
                 Label9->Caption = AnsiString(prah);
                 zmena = 1;
                 vykresli(clRed);
                }
        }

Label7->Caption = AnsiString(cyklus);
if ((zmena == 0) || (cyklus > POCETCYKLU))
 {
        Timer1->Enabled= false;
        Label1->Visible = true;
        if (zmena != 0) Form2->ShowModal();
//        vykresli();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
Timer1->Interval = TrackBar1->Position*10+1;
}
//---------------------------------------------------------------------------
